### carbonquantBuild.cmake --- 
######################################################################
## 
### Commentary: 
## 
######################################################################

# Check the file dtkBuild.cmake before anything since it is already
# included thanks to carbonquantDependencies:
#
# See bellow the include call tree:
# CMakeLists.txt -- carbonquantDependencies.cmake -- dtkUse.cmake -- dtkDependencies.cmake
#                                                         -- dtkBuild.cmake
#                -- carbonquantBuild.cmake
#

## #################################################################
## Show/Hide specific GUI tools (used by developers only)
## #################################################################

if(GUI_USER_MODE)
 set(GUI_USER_MODE_ON 1)
endif(GUI_USER_MODE)

## #################################################################
## SFMT macro
## #################################################################

add_definitions(-DDSFMT_MEXP=19937)

## #################################################################
## Settings
## #################################################################

enable_testing()
enable_language(Fortran)

## #################################################################
## Setup find file
## #################################################################

if(EXISTS ${PROJECT_SOURCE_DIR}/cmake/Find${PROJECT_NAME}.cmake.in)
configure_file( ## Build tree configure file
  ${PROJECT_SOURCE_DIR}/cmake/Find${PROJECT_NAME}.cmake.in
  ${PROJECT_BINARY_DIR}/Find${PROJECT_NAME}.cmake
  @ONLY IMMEDIATE)
endif()

## #################################################################
## Hide settings
## #################################################################

mark_as_advanced(DTK_BUILD_COMPOSER)
mark_as_advanced(DTK_BUILD_DISTRIBUTED)
mark_as_advanced(DTK_BUILD_DOCUMENTATION)
mark_as_advanced(DTK_BUILD_EXAMPLES)
mark_as_advanced(DTK_BUILD_MPI)
mark_as_advanced(DTK_BUILD_PACKAGING)
mark_as_advanced(DTK_BUILD_PLOT)
mark_as_advanced(DTK_BUILD_REPORTING)
mark_as_advanced(DTK_BUILD_SCRIPT)
mark_as_advanced(DTK_BUILD_TESTING)
mark_as_advanced(DTK_BUILD_TOOLS)
mark_as_advanced(DTK_BUILD_TUTORIALS)
mark_as_advanced(DTK_BUILD_VR)
mark_as_advanced(DTK_BUILD_WRAPPERS)
mark_as_advanced(carbonquant_DIR)
mark_as_advanced(dtk_DIR)
mark_as_advanced(qwt_DIR)
mark_as_advanced(qwt3d_DIR)

####################################################################
## Windows
####################################################################

if(WIN32)
  set (CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKED_FLAGS} -Wl,--enable-auto-import")
  set (CMAKE_SHARED_LINKER_FLAGS_DEBUG "${CMAKE_SHARED_LINKER_FLAGS_DEBUG} -Wl,--enable-auto-import")
  set (CMAKE_SHARED_LINKER_FLAGS_RELEASE "${CMAKE_SHARED_LINKER_FLAGS_RELEASE} -Wl,--enable-auto-import")
  set (CMAKE_SHARED_LINKER_FLAGS_RELWITHDEBINFO "${CMAKE_SHARED_LINKER_FLAGS_RELWITHDEBINFO} -Wl,--enable-auto-import")
endif()
