### carbonquantDependencies.cmake --- 
######################################################################
## 
### Commentary: 
## 
######################################################################

# Check the file dtkDependencies.cmake before anything since it is already
# included thanks to "include(${dtk_USE_FILE})":
#
# See bellow the include call tree:
# CMakeLists.txt -- carbonquantDependencies.cmake -- dtkUse.cmake -- dtkDependencies.cmake
#                                                         -- dtkBuild.cmake
#                -- carbonquantBuild.cmake
#

## #################################################################
## Qwt
## #################################################################

include(qwtConfig)
#find_package(qwt REQUIRED)
include(${qwt_USE_FILE})

#find_package(Qwt REQUIRED)
#if(NOT QWT_FOUND)
  #message(FATAL_ERROR "Qwt not found. The following variables are not set : QWT_INCLUDE_DIR and QWT_LIBRARY")
#endif()

## #################################################################
## QwtPlot3d
## #################################################################

include(qwt3dConfig)
#find_package(qwt3d REQUIRED)
include(${qwt3d_USE_FILE})

#find_package(QwtPlot3d REQUIRED)
#if(NOT QWT3D_FOUND)
#  message(FATAL_ERROR "QwtPlot3d not found. The following variables are not set : QWTPLOT3D_INCLUDE_DIR and QWTPLOT3D_LIBRARY")
#endif()

## #################################################################
## DTK
## #################################################################

include(dtkConfig)
#find_package(dtk REQUIRED)
include(${dtk_USE_FILE})

## #################################################################
## SFMT
## #################################################################

include_directories(${CMAKE_SOURCE_DIR}/modules/SFMT)

####################################################################
## OpenMP
####################################################################

set(USE_OPENMP ON CACHE BOOL "Using OpenMP")

if (USE_OPENMP)
  find_package(OpenMP)

  if(OPENMP_FOUND)
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${OpenMP_C_FLAGS}")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${OpenMP_CXX_FLAGS}")
    set(CMAKE_Fortran_FLAGS "${CMAKE_Fortran_FLAGS} ${OpenMP_C_FLAGS}")
    set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} ${OpenMP_EXE_LINKER_FLAGS}")
  endif()

endif(USE_OPENMP)

####################################################################
## Fortran
####################################################################

if(DEFINED CMAKE_Fortran_COMPILER AND CMAKE_Fortran_COMPILER MATCHES "^$")
  set(CMAKE_Fortran_COMPILER CMAKE_Fortran_COMPILER-NOTFOUND)
endif(DEFINED CMAKE_Fortran_COMPILER AND CMAKE_Fortran_COMPILER MATCHES "^$")

if(CMAKE_Fortran_COMPILER_WORKS)
  add_definitions(-DHAVE_FORTRAN)
else(CMAKE_Fortran_COMPILER_WORKS)
  message(STATUS "Fortran compiler not found")
endif(CMAKE_Fortran_COMPILER_WORKS)

