#ifndef carbonquant_HEATDEMANDDECOMPOSER_H
#define carbonquant_HEATDEMANDDECOMPOSER_H

#include "carbonquantCogenerationParkModelExport.h"

#include "CHPDecomposer.h"

#include <carbonquantPlants/EnergyPlant.h>
#include <carbonquantCogenerationParkModel/MeritOrder/MeritOrderAlloc.h>

#include <vector>

class NodePlant;
class LinearProductionFunction;
class CHPConcave;
class PiecewiseLinearConcaveProductionFunction;

class CARBONQUANTCOGENERATIONPARKMODEL_EXPORT HeatDemandDecomposer : public CHPDecomposer
{
public:
    HeatDemandDecomposer();
    ~HeatDemandDecomposer();

    virtual void setNode(NodePlant* node);

    double mcostUp(EnergyPlant::Prices* p, const int& reg_num);
    double mcostDown(EnergyPlant::Prices* p, const int& reg_num);
    void decompose(EnergyPlant::Prices* p, double heat_demand);
    std::vector<MeritOrderAlloc::Object*>& getVpp();

private:
    unsigned int& locate_xHde(double heat_demand) const;
    PiecewiseLinearConcaveProductionFunction* pfchp;
    LinearProductionFunction* pfboiler;
    CHPConcave* chp;
};

#endif
