#ifndef carbonquant_LINEARPRODUCTIONFUNCTION_H
#define carbonquant_LINEARPRODUCTIONFUNCTION_H

#include "carbonquantCogenerationParkModelExport.h"

#include "ProductionFunction.h"

class CARBONQUANTCOGENERATIONPARKMODEL_EXPORT LinearProductionFunction : public ProductionFunction
{
public:
    LinearProductionFunction();

    LinearProductionFunction(double capacity, double rho_el = 0, double rho_th = 0, double rho_em = 0);

    virtual ~LinearProductionFunction();

    void calc_OPoint(EnergyPlant::OPoint& op) const;

    const double& get_capacity() const {return capacity;};
    const double& get_rho_el() const {return rho_el;};
    const double& get_rho_th() const {return rho_th;};
    const double& get_rho_em() const {return rho_em;};

protected:
    double capacity;
    double rho_el;
    double rho_th;
    double rho_em;
};

#endif
