#ifndef carbonquant_MERITORDERALLOC_H
#define carbonquant_MERITORDERALLOC_H

#include "carbonquantCogenerationParkModelExport.h"

#include <vector>

// Merit order object

class CARBONQUANTCOGENERATIONPARKMODEL_EXPORT MeritOrderAlloc
{
public:

    enum Type
    {
        BasicMO, mcCapMO
    };

    struct Object
    {
       double ymax;
       double yopt;
       double mcost;
       Object(double& ymax, double& mcost, double yopt = 0) : ymax(ymax), mcost(mcost), yopt(yopt) {};
    };

    MeritOrderAlloc(unsigned int nsys = 0);
    MeritOrderAlloc(std::vector<Object*>& Y);
    ~MeritOrderAlloc();

    virtual void calc_MOA_regimes();

    static bool mod_lesser(Object *elem1, Object *elem2)
    {
        return (elem1->mcost < elem2->mcost) ? true : false;
    }

protected:
    Type moaType;
    std::vector<Object*> Y;
    unsigned int nsys;
    unsigned int iStop;
    virtual bool StopAllocTest(unsigned int& iTest) = 0;
    virtual void FullAllocFunc(unsigned int& idxIn) = 0;
    virtual void RestAllocFunc(unsigned int& iStop) = 0;
};

#endif
