#ifndef carbonquant_PARK_H
#define carbonquant_PARK_H

#include "carbonquantCogenerationParkModelExport.h"

#include <carbonquantPlants/EnergyPlant.h>

#include <vector>

class Boiler;
class CHPPlant;
class NodePlant;

class CARBONQUANTCOGENERATIONPARKMODEL_EXPORT Park
{
public:

    enum Problem
    {
        NOSALENOTRANSCOST,
        SALENOTRANSCOST,
        SALEANDTRANSCOST
    };

    Park();
    virtual ~Park();

    void setNbNodes (unsigned int nb_nodes);
    void setHde (std::vector<double>& Hde);
    void setPde (std::vector<double>& Pde);
    void setNodeI(CHPPlant* chp, Boiler* boiler, unsigned int number);
    //    void setExchCost (matrix<double>& exch_cost);

    virtual void static_optim (std::vector<double>& Hde, std::vector<double>& Pde, EnergyPlant::Prices& p) = 0;

protected:
    unsigned int nb_nodes;
    std::vector<NodePlant*> nodes;
    Problem setting;
};

#endif
