#ifndef carbonquant_PIECEWISELINEARCONCAVEPRODUCTIONFUNCTION_H
#define carbonquant_PIECEWISELINEARCONCAVEPRODUCTIONFUNCTION_H

#include "carbonquantCogenerationParkModelExport.h"

#include "ProductionFunction.h"

#include <vector>

class CARBONQUANTCOGENERATIONPARKMODEL_EXPORT PiecewiseLinearConcaveProductionFunction : public ProductionFunction
{
public:
    PiecewiseLinearConcaveProductionFunction();

    PiecewiseLinearConcaveProductionFunction(std::vector<double>& reg_bds_tab);

    virtual ~PiecewiseLinearConcaveProductionFunction();

    void setPowTab(std::vector<double>& P_el_tab, std::vector<double>& P_th_tab, std::vector<double>& P_em_tab);
    void setRhoTab(std::vector<double>& rho_el_tab, std::vector<double>& rho_th_tab, std::vector<double>& rho_em_tab);

    void calc_OPoint(EnergyPlant::OPoint& op) const;

    unsigned int get_nbRegimes()  const  {return nbRegimes;};
    const std::vector<double>& get_reg_bds_tab() const {return reg_bds_tab;};
    const std::vector<double>& get_rho_el_tab() const {return rho_el_tab;};
    const std::vector<double>& get_rho_th_tab() const {return rho_th_tab;};
    const std::vector<double>& get_rho_em_tab() const {return rho_em_tab;};
    const std::vector<double>& get_P_el_tab() const {return P_el_tab;};
    const std::vector<double>& get_P_th_tab() const {return P_th_tab;};
    const std::vector<double>& get_P_em_tab() const {return P_em_tab;};

protected:
    void computePow(std::vector<double>& rho, std::vector<double>& pow);
    void computeRho(std::vector<double>& pow, std::vector<double>& rho);
    unsigned int nbRegimes;
    std::vector<double> reg_bds_tab;
    std::vector<double> rho_el_tab;
    std::vector<double> rho_th_tab;
    std::vector<double> rho_em_tab;
    std::vector<double> P_el_tab;
    std::vector<double> P_th_tab;
    std::vector<double> P_em_tab;
};

#endif
