/* carbonquantComposer.h ---

/* Commentary:
 *
 */

#ifndef CARBONQUANTCOMPOSER_H
#define CARBONQUANTCOMPOSER_H

#include "carbonquantComposerExport.h"

#include <dtkComposer>

#include <QtCore>
#include <QtGui>

class dtkComposerSceneNodeComposite;

class carbonquantComposerFactory;
class carbonquantComposerPrivate;

class CARBONQUANTCOMPOSER_EXPORT carbonquantComposer : public QWidget
{
    Q_OBJECT

public:
     carbonquantComposer(QWidget *parent = 0);
    ~carbonquantComposer(void);

public slots:
    bool   open(const QUrl& url);
    bool   open(QString file);
    bool   save(QString file = QString(), dtkComposerWriter::Type type = dtkComposerWriter::Ascii);
    bool insert(QString file);

public slots:
    QFuture<void> run(void);
    void step(void);
    void cont(void);
    void next(void);
    void stop(void);

public:
    bool read(const QString&);

    void clear(void);

signals:
    void modified(bool);
    void evaluationStopped(void);

public:
    dtkComposerEvaluator *evaluator(void);
    dtkComposerCompass *compass(void);
    dtkComposerMachine *machine(void);
    dtkComposerGraph *graph(void);
    dtkComposerScene *scene(void);
    dtkComposerStack *stack(void);
    dtkComposerView *view(void);

public:
    dtkComposerFactory *factory(void);

public:
    void updateRemotes(dtkComposerSceneNodeComposite * composite);

private:
    carbonquantComposerPrivate *d;
};

#endif // carbonquantComposer.h
