/* carbonquantComposerNodeHJBInitialConditions.h --- 
 */

/* Commentary: 
 * 
 */

#ifndef CARBONQUANTCOMPOSERNODEHJBINITIALCONDITIONS_H
#define CARBONQUANTCOMPOSERNODEHJBINITIALCONDITIONS_H

#include "carbonquantComposerExport.h"

#include <dtkComposer/dtkComposerNodeLeafProcess.h>

class carbonquantComposerNodeHJBInitialConditionsPrivate;

class CARBONQUANTCOMPOSER_EXPORT carbonquantComposerNodeHJBInitialConditions : public dtkComposerNodeLeafProcess
{
public:
     carbonquantComposerNodeHJBInitialConditions(void);
    ~carbonquantComposerNodeHJBInitialConditions(void);

public:
    bool isAbstractProcess(void) const {return true;};

    QString abstractProcessType(void) const {return "carbonquantHJBAbstractInitialConditions";};

public:
    inline QString type(void) {
        return "carbonquantHJBAbstractInitialConditions";
    }

    inline QString titleHint(void) {
        return "HJB Initial Conditions";
    }

public:
    inline QString inputLabelHint(int port) {

        switch (port) {
        case 0: return "Grid";
        case 1: return "Value Function Approximation";
        case 2: return "Data";
        }

        return "input";

    }

    inline QString outputLabelHint(int port) {

        switch (port) {
        case 0: return "Value Function Approximation";
        }

        return "output";

    }

public:
    void run(void);

private:
    carbonquantComposerNodeHJBInitialConditionsPrivate *d;
};

#endif
