/* carbonquantComposerNodeHJBSparseMatrixBuilderSolver.h --- 
 */

/* Commentary: Header of node for sparse matrix builder solver
 * 
 */

#ifndef CARBONQUANTCOMPOSERNODEHJBSPARSEMATRIXBUILDERSOLVER_H
#define CARBONQUANTCOMPOSERNODEHJBSPARSEMATRIXBUILDERSOLVER_H

#include "carbonquantComposerExport.h"

#include <dtkComposer/dtkComposerNodeLeaf.h>

class carbonquantComposerNodeHJBSparseMatrixBuilderSolverPrivate;

// /////////////////////////////////////////////////////////////////
// carbonquantComposerNodeHJBSparseMatrixBuilderSolver interface
// /////////////////////////////////////////////////////////////////

class CARBONQUANTCOMPOSER_EXPORT carbonquantComposerNodeHJBSparseMatrixBuilderSolver : public dtkComposerNodeLeaf
{
public:
     carbonquantComposerNodeHJBSparseMatrixBuilderSolver(void);
    ~carbonquantComposerNodeHJBSparseMatrixBuilderSolver(void);

public:
    inline QString type(void) {
        return "carbonquantHJBSparseMatrixBuilderSolver";
    }

    inline QString titleHint(void) {
        return "HJB Sparse Matrix Builder Solver";
    }

public:
    inline QString inputLabelHint(int port) {

        if (port == 0) {
            return "sparse matrix";
        } else if (port == 1) {
            return "scalar";
        }

        return "input";
    }

    inline QString outputLabelHint(int port) {

        if (port == 0)
            return "sparse matrix";

        return "output";
    }

public:
    void run(void);

private:
    carbonquantComposerNodeHJBSparseMatrixBuilderSolverPrivate *d;
};

#endif
