/* carbonquantComposerNodeHJBTimeStepCalculation.h --- 
 */

/* Commentary: 
 * 
 */

#ifndef CARBONQUANTCOMPOSERNODEHJBTIMESTEPCALCULATION_H
#define CARBONQUANTCOMPOSERNODEHJBTIMESTEPCALCULATION_H

#include "carbonquantComposerExport.h"

#include <dtkComposer/dtkComposerNodeLeafProcess.h>

class carbonquantComposerNodeHJBTimeStepCalculationPrivate;

// /////////////////////////////////////////////////////////////////
// carbonquantComposerNodeHJBTimeStepCalculation
// /////////////////////////////////////////////////////////////////

class CARBONQUANTCOMPOSER_EXPORT carbonquantComposerNodeHJBTimeStepCalculation : public dtkComposerNodeLeafProcess
{
public:
     carbonquantComposerNodeHJBTimeStepCalculation(void);
    ~carbonquantComposerNodeHJBTimeStepCalculation(void);

public:
    bool isAbstractProcess(void) const {return true;};

    QString abstractProcessType(void) const {return "carbonquantHJBAbstractTimeStepCalculation";};

public:
    inline QString type(void) {
        return "carbonquantHJBAbstractTimeStepCalculation";
    }

    inline QString titleHint(void) {
        return "Time Step Calculation";
    }

public:
    inline QString inputLabelHint(int port) {

        switch (port) {
        case 0: return "spot";
        case 1: return "power array";
        case 2: return "emission";
        case 3: return "wealth";
        case 4: return "grid";
        case 5: return "reference period";
        case 6: return "desired time step";
        case 7: return "maximum number of time steps";
        case 8: return "theta";
        case 9: return "CFL";
        case 10: return "Elasticity Of The Utility Function";
        }

        return "input";

    }

    inline QString outputLabelHint(int port) {

        switch (port) {
        case 0: return "time step";
        case 1: return "number of time steps";
        }

        return "output";

    }

public:
    void run(void);

private:
    carbonquantComposerNodeHJBTimeStepCalculationPrivate *d;
};

#endif
