/* carbonquantComposerNodeSparseMatrixBuilder.h --- 
 */

/* Commentary: Header of node for sparse matrix builder
 * 
 */

#ifndef CARBONQUANTCOMPOSERNODESPARSEMATRIXBUILDER_H
#define CARBONQUANTCOMPOSERNODESPARSEMATRIXBUILDER_H

#include "carbonquantComposerExport.h"

#include <dtkComposer/dtkComposerNodeLeaf.h>

class carbonquantComposerNodeSparseMatrixBuilderPrivate;

// /////////////////////////////////////////////////////////////////
// carbonquantComposerNodeSparseMatrixBuilder interface
// /////////////////////////////////////////////////////////////////

class CARBONQUANTCOMPOSER_EXPORT carbonquantComposerNodeSparseMatrixBuilder : public dtkComposerNodeLeaf
{
public:
     carbonquantComposerNodeSparseMatrixBuilder(void);
    ~carbonquantComposerNodeSparseMatrixBuilder(void);

public:
    inline QString type(void) {
        return "carbonquantSparseMatrixBuilder";
    }

    inline QString titleHint(void) {
        return "Sparse Matrix Builder";
    }

public:
    inline QString inputLabelHint(int port) {

        if (port == 0)
            return "structured grid";

        return "input";
    }

    inline QString outputLabelHint(int port) {

        if (port == 0)
            return "sparse matrix";

        return "output";
    }

public:
    void run(void);

private:
    carbonquantComposerNodeSparseMatrixBuilderPrivate *d;
};

#endif
