/* carbonquantComposerNodeSparseMatrixOperatorModifier.h ---
 */

/* Commentary:
 *
 */

#ifndef CARBONQUANTCOMPOSERNODESPARSEMATRIXOPERATORMODIFIER_H
#define CARBONQUANTCOMPOSERNODESPARSEMATRIXOPERATORMODIFIER_H

#include "carbonquantComposerExport.h"

#include <dtkComposer/dtkComposerNodeLeaf.h>

// /////////////////////////////////////////////////////////////////
// carbonquantComposerNodeSparseMatrixOperatorModifier interface
// /////////////////////////////////////////////////////////////////

class carbonquantComposerNodeSparseMatrixOperatorModifierPrivate;

class CARBONQUANTCOMPOSER_EXPORT carbonquantComposerNodeSparseMatrixOperatorModifier  : public dtkComposerNodeLeaf
{
public:
    carbonquantComposerNodeSparseMatrixOperatorModifier(void);
    ~carbonquantComposerNodeSparseMatrixOperatorModifier(void);

    inline QString inputLabelHint(int port) {
        if (port == 0)
            return "matrix";
        else
            return "value";
    }

    inline QString outputLabelHint(int) {
        return "matrix";
    }

protected:
    carbonquantComposerNodeSparseMatrixOperatorModifierPrivate *d;
};

// //////////////////////////////////////////////////////////////////////////
// carbonquantComposerNodeSparseMatrixOperatorModifierAllMult interface
// /////////////////////////////////////////////////////////////////////////

class CARBONQUANTCOMPOSER_EXPORT carbonquantComposerNodeSparseMatrixOperatorModifierAllMult : public carbonquantComposerNodeSparseMatrixOperatorModifier
{
public:
    void run(void);

public:
    inline QString type(void) {
        return "carbonquantSparseMatrixAllMult";
    }

    inline QString titleHint(void) {
        return "Sparse matrix : Mat * Value";
    }
};

// //////////////////////////////////////////////////////////////////////////
// carbonquantComposerNodeSparseMatrixOperatorModifierAllDivide interface
// /////////////////////////////////////////////////////////////////////////

class CARBONQUANTCOMPOSER_EXPORT carbonquantComposerNodeSparseMatrixOperatorModifierAllDivide : public carbonquantComposerNodeSparseMatrixOperatorModifier
{
public:
    void run(void);

public:
    inline QString type(void) {
        return "carbonquantSparseMatrixAllDivide";
    }

    inline QString titleHint(void) {
        return "Sparse matrix : Mat / Value";
    }
};

// //////////////////////////////////////////////////////////////////////////
// carbonquantComposerNodeSparseMatrixOperatorModifierAllAdd interface
// /////////////////////////////////////////////////////////////////////////

class CARBONQUANTCOMPOSER_EXPORT carbonquantComposerNodeSparseMatrixOperatorModifierAllAdd : public carbonquantComposerNodeSparseMatrixOperatorModifier
{
public:
    void run(void);

public:
    inline QString type(void) {
        return "carbonquantSparseMatrixAllAdd";
    }

    inline QString titleHint(void) {
        return "Sparse matrix : Mat + Value";
    }
};

// //////////////////////////////////////////////////////////////////////////
// carbonquantComposerNodeSparseMatrixOperatorModifierAllSubstract interface
// /////////////////////////////////////////////////////////////////////////

class CARBONQUANTCOMPOSER_EXPORT carbonquantComposerNodeSparseMatrixOperatorModifierAllSubstract : public carbonquantComposerNodeSparseMatrixOperatorModifier
{
public:
    void run(void);

public:
    inline QString type(void) {
        return "carbonquantSparseMatrixAllSubstract";
    }

    inline QString titleHint(void) {
        return "Sparse matrix : Mat - Value";
    }
};

// //////////////////////////////////////////////////////////////////////////
// carbonquantComposerNodeSparseMatrixOperatorModifierAddToDiagonal interface
// /////////////////////////////////////////////////////////////////////////

class CARBONQUANTCOMPOSER_EXPORT carbonquantComposerNodeSparseMatrixOperatorModifierAddToDiagonal : public carbonquantComposerNodeSparseMatrixOperatorModifier
{
public:
    void run(void);

public:
    inline QString type(void) {
        return "carbonquantSparseMatrixAddToDiagonal";
    }

    inline QString titleHint(void) {
        return "Sparse matrix : Diagonal of Mat + Value";
    }
};

// //////////////////////////////////////////////////////////////////////////
// carbonquantComposerNodeSparseMatrixOperatorModifierSubstractToDiagonal interface
// /////////////////////////////////////////////////////////////////////////

class CARBONQUANTCOMPOSER_EXPORT carbonquantComposerNodeSparseMatrixOperatorModifierSubstractToDiagonal : public carbonquantComposerNodeSparseMatrixOperatorModifier
{
public:
    void run(void);

public:
    inline QString type(void) {
        return "carbonquantSparseMatrixSubstractToDiagonal";
    }

    inline QString titleHint(void) {
        return "Sparse matrix : Diagonal of Mat - Value";
    }
};

#endif
