/* carbonquantComposerNodeSparseSystemSolver.h --- 
 * 
 * Author: Régis Duvigneau
 * Copyright (C) 2008 - Regis Duvigneau, Inria.
 * Created: Mon Jul 30 13:51:14 2012 (+0200)
 * Version: $Id$
 * Last-Updated: Thu Nov 29 17:44:37 2012 (+0100)
 *           By: Selim Kraria
 *     Update #: 6
 */

/* Commentary: Header of node for sparse system solver
 * 
 */

/* Change log:
 * 
 */


#ifndef CARBONQUANTCOMPOSERNODESPARSESYSTEMSOLVER_H
#define CARBONQUANTCOMPOSERNODESPARSESYSTEMSOLVER_H

#include "carbonquantComposerExport.h"

#include <dtkComposer/dtkComposerNodeLeafProcess.h>

class carbonquantComposerNodeSparseSystemSolverPrivate;

// /////////////////////////////////////////////////////////////////
// carbonquantComposerNodeSparseSystemSolver interface
// /////////////////////////////////////////////////////////////////

class CARBONQUANTCOMPOSER_EXPORT carbonquantComposerNodeSparseSystemSolver : public dtkComposerNodeLeafProcess
{
public:
     carbonquantComposerNodeSparseSystemSolver(void);
    ~carbonquantComposerNodeSparseSystemSolver(void);

public:
    inline QString type(void) {
        return "carbonquantAbstractSparseSystemSolver";
    }

    inline QString titleHint(void) {
        return "Sparse System Solver";
    }

public:
    inline QString inputLabelHint(int port) {

        switch (port) {
        case 0:
            return "sparse matrix";
        case 1:
            return "left-hand side vector";
        case 2:
            return "right-hand side vector";
        case 3:
            return "max iteration";
        case 4:
            return "min residual norm";
        default:
            return "input";
        }
    }

    inline QString outputLabelHint(int port) {

        if (port == 0)
            return "solution vector";

        return "output";
    }

public:
    bool isAbstractProcess(void) const;

    QString abstractProcessType(void) const;

public:
    void run(void);

private:
    carbonquantComposerNodeSparseSystemSolverPrivate *d;
};

#endif
