/* carbonquantComposerNodeStructuredGridBuilder.h --- 
 */

/* Commentary: 
 * 
 */

#ifndef CARBONQUANTCOMPOSERNODESTRUCTUREDGRIDBUILDER_H
#define CARBONQUANTCOMPOSERNODESTRUCTUREDGRIDBUILDER_H

#include "carbonquantComposerExport.h"

#include <dtkComposer/dtkComposerNodeLeafProcess.h>

#include <QtCore>

class carbonquantComposerNodeStructuredGridBuilderPrivate;

// /////////////////////////////////////////////////////////////////
// carbonquantComposerNodeStructuredGridBuilder interface
// /////////////////////////////////////////////////////////////////

class CARBONQUANTCOMPOSER_EXPORT carbonquantComposerNodeStructuredGridBuilder : public dtkComposerNodeLeafProcess
{
public:
     carbonquantComposerNodeStructuredGridBuilder(void);
    ~carbonquantComposerNodeStructuredGridBuilder(void);

public:
    bool isAbstractProcess(void) const {return false;};

    QString abstractProcessType(void) const {return "carbonquantStructuredGridBuilder";};

public:
    inline QString type(void) {
        return "carbonquantStructuredGridBuilder";
    }

    inline QString titleHint(void) {
        return "StructuredGridBuilder";
    }

public:
    inline QString inputLabelHint(int port) {

        switch (port) {
        case 0: return "Structured Grid";
        case 1: return "Name";
        case 2: return "Minimum Value";
        case 3: return "Maximum Value";
        case 4: return "Number Of Points";
        }

        return "input";

    }

    inline QString outputLabelHint(int port) {

        if (port == 0)
            return "Structured Grid";

        return "output";

    }

public:
    void run(void);

private:
    carbonquantComposerNodeStructuredGridBuilderPrivate *d;
};

#endif
