/* carbonquantAbstractCalibration.h --- 
 */

/* Commentary: 
 * 
 */

#ifndef CARBONQUANTABSTRACTCALIBRATION_H
#define CARBONQUANTABSTRACTCALIBRATION_H

#include "carbonquantCoreExport.h"

#include <dtkCore/dtkAbstractProcess.h>

class Spot;
class Optimizer;
template <class T> class dtkContainerVector;

class carbonquantAbstractCalibrationPrivate;

class CARBONQUANTCORE_EXPORT carbonquantAbstractCalibration : public dtkAbstractProcess
{
    Q_OBJECT

public:
             carbonquantAbstractCalibration(dtkAbstractProcess *parent = 0);
             carbonquantAbstractCalibration(const carbonquantAbstractCalibration&);
    virtual ~carbonquantAbstractCalibration(void);

public:
    carbonquantAbstractCalibration& operator = (const carbonquantAbstractCalibration&);

public:
    virtual QString identifier(void) const;

public:
    virtual void setSpot(const Spot*) = 0;
    virtual void setSpotData(const dtkContainerVector<qreal>*) = 0;
    virtual void setSpotParametersBoundaries(const std::map<std::string, double>*) = 0;
    virtual void setOptimizer(Optimizer*) = 0;
    virtual void setSpotScaleType(const int&) = 0;
    virtual void setUnitOfTime(const QString&) = 0;
    virtual void setStartHourDay(const int&) = 0;
    virtual void setEndHourDay(const int&) = 0;
    virtual void setStartHourNight(const int&) = 0;
    virtual void setEndHourNight(const int&) = 0;
    virtual void setInitialHour(const int&) = 0;

    virtual Spot* spot(void) = 0;
    virtual Spot* spotDayNight(void) = 0;
    virtual const QVector<qreal>* time(void) const = 0;
    virtual const QList<QVector<qreal> >* rentabilityPath(void) const = 0;
    virtual const QList<QVector<qreal> >* pricePath(void) const = 0;
    virtual const QVector<qreal>* timeCDF(void) const = 0;
    virtual const QList<QVector<qreal> >* CDF(void) const = 0;

private:
    DTK_DECLARE_PRIVATE(carbonquantAbstractCalibration);
};
#endif
