/* carbonquantAbstractPDF.h --- 
 */

/* Commentary: 
 * 
 */

#ifndef CARBONQUANTABSTRACTPDF_H
#define CARBONQUANTABSTRACTPDF_H

#include "carbonquantCoreExport.h"

#include <dtkCore/dtkAbstractProcess.h>

class carbonquantData;
class carbonquantReferencePeriod;

class carbonquantAbstractPDFPrivate;

class CARBONQUANTCORE_EXPORT carbonquantAbstractPDF : public dtkAbstractProcess
{
    Q_OBJECT

public:
             carbonquantAbstractPDF(dtkAbstractProcess *parent = 0);
             carbonquantAbstractPDF(const carbonquantAbstractPDF&);
    virtual ~carbonquantAbstractPDF(void);

public:
    carbonquantAbstractPDF& operator = (const carbonquantAbstractPDF&);

public:
    virtual QString identifier(void) const;

public:
    virtual void setData(const carbonquantData*) = 0;
    virtual void setReferencePeriod(const carbonquantReferencePeriod*) = 0;
    virtual void setSimulationTimeStep(const double&) {};
    virtual void setInitialSpotPrice(const double&) = 0;
    virtual void setNumberOfBins(const int&) = 0;
    virtual void setNumberOfMonteCarloSimulations(const int&) = 0;
    virtual void setNumberOfMonteCarloSimulationsPreStep(const int&) {};

public:
    virtual const QVector<qreal>* spotX(void) const = 0;
    virtual const QVector<qreal>* spotY(void) const = 0;
    virtual const QVector<qreal>* totalEmissionX(void) const = 0;
    virtual const QVector<qreal>* totalEmissionY(void) const = 0;
    virtual const QVector<qreal>* totalProductionX(void) const = 0;
    virtual const QVector<qreal>* totalProductionY(void) const = 0;
    virtual const QVector<qreal>* wealthX(void) const = 0;
    virtual const QVector<qreal>* wealthY(void) const = 0;
    virtual const QVector<qreal>* utilityX(void) const = 0;
    virtual const QVector<qreal>* utilityY(void) const = 0;
    virtual const QVector<qreal>* penalityX(void) const = 0;
    virtual const QVector<qreal>* penalityY(void) const = 0;
    virtual const QVector<qreal>* powerPlantsTotalEmission(void) const = 0;
    virtual const QVector<qreal>* powerPlantsTotalProduction(void) const = 0;

private:
    DTK_DECLARE_PRIVATE(carbonquantAbstractPDF);
};
#endif
