/* carbonquantAbstractSimulateControlPath.h --- 
 */

/* Commentary: 
 * 
 */

#ifndef CARBONQUANTABSTRACTSIMULATECONTROLPATH_H
#define CARBONQUANTABSTRACTSIMULATECONTROLPATH_H

#include "carbonquantCoreExport.h"

#include <dtkCore/dtkAbstractProcess.h>

class carbonquantData;
class carbonquantReferencePeriod;
template <class T> class dtkContainerVector;

class carbonquantAbstractSimulateControlPathPrivate;

class CARBONQUANTCORE_EXPORT carbonquantAbstractSimulateControlPath : public dtkAbstractProcess
{
    Q_OBJECT

public:
             carbonquantAbstractSimulateControlPath(dtkAbstractProcess *parent = 0);
             carbonquantAbstractSimulateControlPath(const carbonquantAbstractSimulateControlPath&);
    virtual ~carbonquantAbstractSimulateControlPath(void);

public:
    carbonquantAbstractSimulateControlPath& operator = (const carbonquantAbstractSimulateControlPath&);

public:
    virtual QString identifier(void) const;

public:
    virtual void setData(const carbonquantData*) = 0;
    virtual void setReferencePeriod(const carbonquantReferencePeriod*) = 0;
    virtual void setSimulationTimeStep(const double&) {};
    virtual void setSpotData(const dtkContainerVector<qreal>*) = 0;
    virtual void setValueFunctionHJBFile(const QString&) {};

    virtual const QVector<qreal>* time(void) const = 0;
    virtual const QVector<qreal>* wealth(void) const = 0;
    virtual const QVector<qreal>* wealthUtility(void) const = 0;
    virtual const QVector<qreal>* cumulatedTotalEmission(void) const = 0;
    virtual const QVector<qreal>* cumulatedTotalProductionCapacityUsed(void) const = 0;
    virtual const QVector<qreal>* totalProductionCapacityUsed(void) const = 0;
    virtual const QList<QVector<qreal> >* powerPlantsProductionCapacityUsed(void) const = 0;
    virtual const QVector<qreal>* meanTimePowerPlantsProductionCapacityUsed(void) const = 0;

private:
    DTK_DECLARE_PRIVATE(carbonquantAbstractSimulateControlPath);
};
#endif
