/* carbonquantData.h --- 
 */

/* Commentary: 
 * 
 */

#ifndef CARBONQUANTDATA_H
#define CARBONQUANTDATA_H

#include "carbonquantCoreExport.h"

#include <dtkCore/dtkAbstractData.h>

class Spot;
class Emission;
class Wealth;
class Control;
class Utility;
class Tax;
class PowerArray;

class carbonquantDataPrivate;

// /////////////////////////////////////////////////////////////////
// carbonquantData interface
// /////////////////////////////////////////////////////////////////

class CARBONQUANTCORE_EXPORT carbonquantData : public dtkAbstractData
{
    Q_OBJECT

public:
    carbonquantData(void);
    carbonquantData(const carbonquantData& other);
    ~carbonquantData(void);
    
public:
    carbonquantData& operator = (const carbonquantData& other);

    bool operator == (const carbonquantData& other) const;

public:
    QString identifier(void) const;

public:
    void setSpot(const Spot*);
    void setEmission(const Emission*);
    void setWealth(const Wealth*);
    void setControl(const Control*);
    void setUtility(const Utility*);
    void setTax(const Tax*);
    void setPowerArray(const PowerArray*);

public:
    const Spot* spot(void) const;
    const Emission* emission(void) const;
    const Wealth* wealth(void) const;
    const Control* control(void) const;
    const Utility* utility(void) const;
    const Tax* tax(void) const;
    const PowerArray* powerArray(void) const;

protected:
    void update(void);

private:
    DTK_DECLARE_PRIVATE(carbonquantData);
};

// /////////////////////////////////////////////////////////////////
// Instanciation function
// /////////////////////////////////////////////////////////////////

CARBONQUANTCORE_EXPORT dtkAbstractData *createCarbonquantData(void);

// /////////////////////////////////////////////////////////////////
//
// /////////////////////////////////////////////////////////////////

Q_DECLARE_METATYPE(carbonquantData);
Q_DECLARE_METATYPE(carbonquantData *);

#endif
