/* carbonquantData_p.h --- 
 */

/* Commentary: 
 * 
 */

#ifndef CARBONQUANTDATA_P_H
#define CARBONQUANTDATA_P_H

#include "carbonquantCoreExport.h"

#include <dtkCore/dtkAbstractData_p.h>

class carbonquantData;

// /////////////////////////////////////////////////////////////////
// carbonquantDataPrivate interface
// /////////////////////////////////////////////////////////////////

class CARBONQUANTCORE_EXPORT carbonquantDataPrivate : public dtkAbstractDataPrivate
{
    DTK_DECLARE_PUBLIC(carbonquantData);

public:
    carbonquantDataPrivate(carbonquantData *q = 0) : dtkAbstractDataPrivate(q) {}
    carbonquantDataPrivate(const carbonquantDataPrivate& other) : dtkAbstractDataPrivate(other) {}

public:
    ~carbonquantDataPrivate(void) {}

public:
    const Spot *spot;
    const Emission *emission;
    const Wealth *wealth;
    const Control *control;
    const Utility *utility;
    const Tax *tax;
    const PowerArray *powerArray;
};

// /////////////////////////////////////////////////////////////////
// carbonquantData protected constructors
// /////////////////////////////////////////////////////////////////

DTK_IMPLEMENT_PRIVATE(carbonquantData, dtkAbstractData);

// /////////////////////////////////////////////////////////////////
// carbonquantDataPrivate documentation
// /////////////////////////////////////////////////////////////////

/*! \class carbonquantDataPrivate
 *
 *  \brief Class carbonquantDataPrivate is the private implementation of the
 *  carbonquantData class.
 *
 */

#endif
