/* carbonquantReferencePeriod.h --- 
 */

/* Commentary: 
 * 
 */

#ifndef CARBONQUANTREFERENCEPERIOD_H
#define CARBONQUANTREFERENCEPERIOD_H

#include "carbonquantCoreExport.h"

#include <dtkCore/dtkAbstractData.h>

class carbonquantReferencePeriodPrivate;

// /////////////////////////////////////////////////////////////////
// carbonquantReferencePeriod interface
// /////////////////////////////////////////////////////////////////

class CARBONQUANTCORE_EXPORT carbonquantReferencePeriod : public dtkAbstractData
{
    Q_OBJECT

public:
    enum UnitOfTime {
        Hour,
        Day,
        Week,
        Month,
        Year
    };

public:
    carbonquantReferencePeriod(void);
    carbonquantReferencePeriod(const carbonquantReferencePeriod& other);
    ~carbonquantReferencePeriod(void);
    
public:
    carbonquantReferencePeriod& operator = (const carbonquantReferencePeriod& other);

    bool operator == (const carbonquantReferencePeriod& other) const;

public:
    QString identifier(void) const;

public:
    void setStartDate(const QString&);
    void setStartHour(const QString&);
    void setEndDate(const QString&);
    void setEndHour(const QString&);
    void setUnitOfTime(const QString&);

public:
    const double& timeMinimum(void) const;
    const double& timeMaximum(void) const;
    const double& duration(void) const;
    const double& scaleHour(void) const;

protected:
    void update(void);

private:
    DTK_DECLARE_PRIVATE(carbonquantReferencePeriod);
};

// /////////////////////////////////////////////////////////////////
// Instanciation function
// /////////////////////////////////////////////////////////////////

CARBONQUANTCORE_EXPORT dtkAbstractData *createCarbonquantReferencePeriod(void);

// /////////////////////////////////////////////////////////////////
//
// /////////////////////////////////////////////////////////////////

Q_DECLARE_METATYPE(carbonquantReferencePeriod);
Q_DECLARE_METATYPE(carbonquantReferencePeriod *);

#endif
