/* carbonquantGrid.h --- 
 */

/* Commentary: 
 * 
 */

#ifndef CARBONQUANTGRID_H
#define CARBONQUANTGRID_H

#include "carbonquantGuiExport.h"

#include <QtGui/QFrame>

class carbonquantGridPrivate;

class CARBONQUANTGUI_EXPORT carbonquantGrid : public QFrame
{
    Q_OBJECT

public:
    carbonquantGrid(const int& numberOfColumns = 1, bool scrolled = true, QWidget *parent = 0);
    ~carbonquantGrid(void);

    void addWidget(QWidget*);
    void removeWidget(QWidget*);
    void removeAllWidgets(void);

    int numberOfWidgets(void) const;

    QWidget* widget(int) const;
    QWidget* viewport(void) const;

    void updateGrid(void);

    void clearGrid(void);

protected:
    void placeWidgets(void);

public slots:
    void setNumberOfColumns(const int&);

private:
    carbonquantGridPrivate *d;
};

#endif
