/* carbonquantGroupBox.h --- 
 */

/* Commentary: 
 * 
 */

#ifndef CARBONQUANTGROUPBOX_H
#define CARBONQUANTGROUPBOX_H

#include "carbonquantGuiExport.h"

#include <QtGui/QGroupBox>

class carbonquantGroupBoxPrivate;

class CARBONQUANTGUI_EXPORT carbonquantGroupBox : public QGroupBox
{
    Q_OBJECT

public:
    carbonquantGroupBox(const QString&, int numberOfColumns = 2, QWidget *parent = 0);
    ~carbonquantGroupBox(void);

    void addRow(const QString&, QWidget*, const QString& tag = "", const uint& labelWidth = 0, const uint& fieldWidth = 0);
    void addRow(QWidget*);
    void removeRow(int);

    void setVisibleRow(QWidget *, bool);

    void setLabelsWidth(const uint&);
    void setFieldsWidth(const uint&);

    QWidget* labelFromWidget(QWidget*) const;
    QWidget* fieldFromTag(const QString&) const;

    int numberOfRows(void);

    bool event(QEvent*);

    static void resizeGroupBoxes(const QList<carbonquantGroupBox *>&, const uint& labelWidth = 0, const uint& fieldWidth = 0);
    static void joinGroupBoxes(const QList<carbonquantGroupBox *>&, QLayout*);

private:
    carbonquantGroupBoxPrivate *d;
};

#endif
