/* carbonquantPDFTab.h --- 
 */

/* Commentary: 
 * 
 */

#ifndef CARBONQUANTPDFTAB_H
#define CARBONQUANTPDFTAB_H

#include "carbonquantGuiExport.h"

#include <QtGui/QFrame>

class carbonquantSpotTab;
class carbonquantPortfolioTab;
class carbonquantComposerTab;
class carbonquantPDFView;

class carbonquantPDFTabPrivate;

class CARBONQUANTGUI_EXPORT carbonquantPDFTab : public QFrame
{
    Q_OBJECT

public:
     carbonquantPDFTab(QWidget *parent = 0);
    ~carbonquantPDFTab(void);

    void setSpotTab(carbonquantSpotTab*);
    void setPortfolioTab(carbonquantPortfolioTab*);
    void setComposerTab(carbonquantComposerTab*);

    const carbonquantPDFView* pdfView(void) const;

    int numberOfMonteCarloSimulations(void) const;
    int numberOfMonteCarloSimulationsPreStep(void) const;
    int numberOfBins(void) const;
    int resetGraphsBeforeSimulation(void) const;

    void setNumberOfMonteCarloSimulations(const int&);
    void setNumberOfMonteCarloSimulationsPreStep(const int&);
    void setNumberOfBins(const int&);
    void setResetGraphsBeforeSimulation(const int&);

    void clean(void);

protected:
    bool checkData(void);

    void exportGraphsData(const QString&);

signals:
    void pdfClicked(void);

protected slots:
    void onPDFRunClicked(void);

    void onShowAreaData(bool);

    void addGraphsData(void);
    void exportGraphsData(void);
    void addGraphsData(const QString&);

private:
    carbonquantPDFTabPrivate *d;
};

#endif
