/* carbonquantPlotViewInspectorSettings.h --- 
 */

/* Commentary: 
 * 
 */

#ifndef CARBONQUANTPLOTVIEWINSPECTORSETTINGS_H
#define CARBONQUANTPLOTVIEWINSPECTORSETTINGS_H

#include "carbonquantGuiExport.h"

#include "carbonquantAbstractViewInspectorSettings.h"

class dtkAbstractView;

class carbonquantPlotViewInspectorSettingsPrivate;

class CARBONQUANTGUI_EXPORT carbonquantPlotViewInspectorSettings : public carbonquantAbstractViewInspectorSettings
{
    Q_OBJECT

public:
     carbonquantPlotViewInspectorSettings(QWidget *parent = 0);
    ~carbonquantPlotViewInspectorSettings(void);

public:
     void setMainTitle(const QString&);
     void setAxisTitleX(const QString&);
     void setAxisTitleY(const QString&);
     void setTitleSize(const int&);
     void setAxesTitleSize(const int&);
     void setLegendSize(const int&);
     void setLegendVisible(bool);
     void setLegendPosition(int);
     void setGridVisible(bool);
     void setAlphaCurveAreaColor(const int&);
     void setBackgroundColor(const QColor&);
     void setForegroundColor(const QColor&);

     void setView(dtkAbstractView*);

protected:
     void updateCurves(void);

public slots:
     void updateView(void);
     void update(void);

protected slots:
     void updateCurveName(int);
     void updateCurveColor(int);
     void updateCurvesColor(const QColor&);

private:
    carbonquantPlotViewInspectorSettingsPrivate *d;
};

#endif
