/* carbonquantPortfolioTab.h --- 
 */

/* Commentary: 
 * 
 */

#ifndef CARBONQUANTPORTFOLIOTAB_H
#define CARBONQUANTPORTFOLIOTAB_H

#include "carbonquantGuiExport.h"

#include <QtGui/QFrame>

class carbonquantSpotTab;
class carbonquantComposerTab;
class carbonquantPortfolioView;

class carbonquantPortfolioTabPrivate;

class CARBONQUANTGUI_EXPORT carbonquantPortfolioTab : public QFrame
{
    Q_OBJECT

public:
     carbonquantPortfolioTab(QWidget *parent = 0);
    ~carbonquantPortfolioTab(void);

    void setSpotTab(carbonquantSpotTab*);
    void setComposerTab(carbonquantComposerTab*);

    carbonquantPortfolioView* portfolioView(void) const;

    QString spotFileName(void);

    double wealth(void) const;
    double utility(void) const;
    double emission(void) const;
    int taxState(void) const;
    int taxType(void) const;
    double taxRate(void) const;
    double allocation(void) const;
    double otcElectricityProduction(void) const;
    double otcPrice(void) const;
    int controlPathType(void) const;
    QString valueFunctionHJBFileName(void) const;
    int resetGraphsBeforeSimulation(void) const;
    uint numberOfPowerPlants(void) const;
    QString powerPlantName(const uint& index) const;
    double powerPlantCapacity(const uint&) const;
    double powerPlantCost(const uint&) const;
    double powerPlantEmission(const uint&) const;

    void setWealth(const double&);
    void setUtility(const double&);
    void setEmission(const double&);
    void setTaxState(const int&);
    void setTaxType(const int&);
    void setTaxRate(const double&);
    void setAllocation(const double&);
    void setOtcElectricityProduction(const double&);
    void setOtcPrice(const double&);
    void setControlPathType(const int&);
    void setValueFunctionHJBFileName(const QString&);
    void setResetGraphsBeforeSimulation(const int&);
    void setPowerPlantName(const uint&, const QString&);
    void setPowerPlantCapacity(const uint&, const double&);
    void setPowerPlantCost(const uint&, const double&);
    void setPowerPlantEmission(const uint&, const double&);

    void clean(void);

protected:
    bool checkData(void);

    void exportGraphsData(const QString&);

signals:
    void controlPathClicked(void);

public slots:
    void powerAdded(void);

protected slots:
    void onTaxStateClicked(int state);
    void onTaxTypeChanged(int index = 0);

    void onControlPathTypeChanged(int index = 0);
    void onValueFunctionHJBFile(void);

    void powerRemoved(QWidget*);

    void onControlPathRunClicked(void);

    void onShowAreaData(bool);

    void addGraphsData(void);
    void exportGraphsData(void);
    void addGraphsData(const QString&);

private:
    carbonquantPortfolioTabPrivate *d;
};

#endif
