/* carbonquantSpotView.h --- 
 */

/* Commentary: 
 * 
 */

#ifndef CARBONQUANTSPOTVIEW_H
#define CARBONQUANTSPOTVIEW_H

#include "carbonquantGuiExport.h"

#include "carbonquantSpotTab.h"

#include <QtGui/QFrame>

class dtkAbstractView;

class carbonquantSpotViewPrivate;

class CARBONQUANTGUI_EXPORT carbonquantSpotView : public QFrame
{
    Q_OBJECT

public:
     carbonquantSpotView(QWidget *parent = 0);
    ~carbonquantSpotView(void);

    void showCalibration(bool value = true);

    QList<double> spotPlotViewPrices(void) const;

    QStringList defaultCurveNames(const QString&, carbonquantSpotTab::SpotType) const;

    const QMap<QString, const dtkAbstractView*>& views(void) const;

    void clear(void);
    void clearSpot(void);
    void clearCalibration(void);

    void updateSpotViewLayout(void);
    void updateCalibrationViewLayout(void);

signals:
    void showAreaData(bool);
    void exportGraphs(void);

public slots:
    void updateViewLayout(void);

private:
    carbonquantSpotViewPrivate *d;
};

#endif
