/* carbonquantAbstractSparseSystemSolver.h ---
 *
 * Author: Regis Duvigneau
 */

/* Commentary:
 *
 */

/* Change log:
 *
 */

#ifndef CARBONQUANTABSTRACTSPARSESYSTEMSOLVER_H
#define CARBONQUANTABSTRACTSPARSESYSTEMSOLVER_H

#include <dtkCore/dtkAbstractProcess.h>

#include "carbonquantHJBExport.h"

class carbonquantSparseMatrix;
template <class T> class dtkContainerVector;

class carbonquantAbstractSparseSystemSolverPrivate;

// /////////////////////////////////////////////////////////////////
// carbonquantAbstractSparseSystemSolver interface
// /////////////////////////////////////////////////////////////////

class CARBONQUANTHJB_EXPORT carbonquantAbstractSparseSystemSolver : public dtkAbstractProcess
{
    Q_OBJECT
    
public:
    carbonquantAbstractSparseSystemSolver(void);
    carbonquantAbstractSparseSystemSolver(const carbonquantAbstractSparseSystemSolver& other);
    virtual ~carbonquantAbstractSparseSystemSolver(void);
    
public:
    carbonquantAbstractSparseSystemSolver& operator = (const carbonquantAbstractSparseSystemSolver& other);

protected:
    virtual void copy(const dtkAbstractObject& other);
    
public:
    QString identifier(void) const;
    
public:
    virtual void setMatrix(carbonquantSparseMatrix*) = 0;
    virtual void setLeftHandSide(dtkContainerVector<qreal>*) = 0;
    virtual void setRightHandSide(dtkContainerVector<qreal>*) = 0;
    virtual void setMaxIterationNumber(qlonglong);
    virtual void setMinResidualReduction(qlonglong);

public:
     virtual dtkContainerVector<qreal>* solutionVector(void) = 0;
    
private:
    DTK_DECLARE_PRIVATE(carbonquantAbstractSparseSystemSolver);
};

#endif


