/* carbonquantHJBAbstractDiscreteScheme.h --- 
 */

/* Commentary: 
 * 
 */

#ifndef CARBONQUANTHJBABSTRACTDISCRETESCHEME_H
#define CARBONQUANTHJBABSTRACTDISCRETESCHEME_H

#include <dtkCore/dtkAbstractProcess.h>

#include "carbonquantHJBExport.h"

class carbonquantStructuredGrid;
class carbonquantStructuredGridBoundary;
class carbonquantSparseMatrix;
class carbonquantData;
template <class T> class dtkContainerVector;

class carbonquantHJBAbstractDiscreteSchemePrivate;

// /////////////////////////////////////////////////////////////////
// 
// /////////////////////////////////////////////////////////////////

class CARBONQUANTHJB_EXPORT carbonquantHJBAbstractDiscreteScheme : public dtkAbstractProcess
{
    Q_OBJECT
    
public:
             carbonquantHJBAbstractDiscreteScheme(void);
             carbonquantHJBAbstractDiscreteScheme(const carbonquantHJBAbstractDiscreteScheme& other);
    virtual ~carbonquantHJBAbstractDiscreteScheme(void);

public:
    carbonquantHJBAbstractDiscreteScheme& operator = (const carbonquantHJBAbstractDiscreteScheme& other);

public:
    virtual QString identifier(void) const;

public:
    virtual void setSystemMatrix(carbonquantSparseMatrix*) = 0;
    virtual void setContributionRhsVector(dtkContainerVector<qreal>*) = 0;
    virtual void setStructuredGrid(carbonquantStructuredGrid*) = 0;
    virtual void setIndexesList(const dtkContainerVector<QVector<qlonglong> >*) = 0;
    virtual void setData(const carbonquantData*) = 0;
    virtual void setU(const dtkContainerVector<qreal>*) = 0;

    // Only used in Boundary stuff
    virtual void setBoundaryConditions(const carbonquantStructuredGridBoundary*) {};

public:
    virtual carbonquantSparseMatrix *systemMatrix(void) = 0;
    virtual dtkContainerVector<qreal> *contributionRhsVector(void) = 0;

private:
    DTK_DECLARE_PRIVATE(carbonquantHJBAbstractDiscreteScheme);
};

#endif
