/* carbonquantHJBAbstractTimeStepCalculation.h ---
 */

/* Commentary: 
 * 
 */

#ifndef CARBONQUANTHJBABSTRACTTIMESTEPCALCULATION_H
#define CARBONQUANTHJBABSTRACTTIMESTEPCALCULATION_H

#include <dtkCore/dtkAbstractProcess.h>

#include "carbonquantHJBExport.h"

class Spot;
class PowerArray;
class Emission;
class Wealth;
class carbonquantStructuredGrid;
class carbonquantReferencePeriod;

class carbonquantHJBAbstractTimeStepCalculationPrivate;

// /////////////////////////////////////////////////////////////////
// carbonquantHJBAbstractTimeStepCalculation interface
// /////////////////////////////////////////////////////////////////

class CARBONQUANTHJB_EXPORT carbonquantHJBAbstractTimeStepCalculation : public dtkAbstractProcess
{
    Q_OBJECT
    
public:
             carbonquantHJBAbstractTimeStepCalculation(void);
             carbonquantHJBAbstractTimeStepCalculation(const carbonquantHJBAbstractTimeStepCalculation& other);
    virtual ~carbonquantHJBAbstractTimeStepCalculation(void);

public:
    carbonquantHJBAbstractTimeStepCalculation& operator = (const carbonquantHJBAbstractTimeStepCalculation& other);

public:
    virtual QString identifier(void) const;

public:
    virtual void setSpot(Spot*) = 0;
    virtual void setPowerArray(PowerArray*) = 0;
    virtual void setEmission(Emission*) = 0;
    virtual void setWealth(Wealth*) = 0;
    virtual void setStructuredGrid(const carbonquantStructuredGrid*) = 0;
    virtual void setReferencePeriod(const carbonquantReferencePeriod*) = 0;
    virtual void setTimeStepUser(const qreal&) {};
    virtual void setMaximumNumberOfTimeSteps(const qlonglong&) {};
    virtual void setTheta(const qreal&) = 0;
    virtual void setCFL(const qreal&) = 0;
    virtual void setElasticityOfTheUtilityFunction(const qreal&) = 0;

public:
    virtual const qreal& timeStepRun(void) const = 0;
    virtual const qlonglong& numberOfTimeSteps(void) const = 0;

private:
    DTK_DECLARE_PRIVATE(carbonquantHJBAbstractTimeStepCalculation);
};

#endif
