/* carbonquantSparseMatrix.h ---
 */

/* Commentary:
 *
 */

/* Change log:
 *
 */

#ifndef CARBONQUANTSPARSEMATRIX_H
#define CARBONQUANTSPARSEMATRIX_H

#include <dtkCore/dtkAbstractData.h>

#include "carbonquantHJBExport.h"

template <class T> class dtkContainerVector;

class carbonquantSparseMatrixPrivate;

// /////////////////////////////////////////////////////////////////
// carbonquantSparseMatrix interface
// /////////////////////////////////////////////////////////////////

class CARBONQUANTHJB_EXPORT carbonquantSparseMatrix : public dtkAbstractData
{
    Q_OBJECT
    
public:
    carbonquantSparseMatrix(void);
    carbonquantSparseMatrix(const carbonquantSparseMatrix& other);
    virtual ~carbonquantSparseMatrix(void);
    
public:
    virtual carbonquantSparseMatrix *clone(void); // If your class is pure virtual you need to set this method to pure virtual too! 
    
public:
    carbonquantSparseMatrix& operator = (const carbonquantSparseMatrix& other);
    
protected:
    virtual void copy(const dtkAbstractObject& other);
    
public:
    bool operator == (const carbonquantSparseMatrix& other) const;
    
protected:
    virtual bool isEqual(const dtkAbstractObject& other) const;
    
public:
    QString identifier(void) const;
    
public:
    void initialize(int line_number, int non_zero_coeff_number);
    void addCoefficient(qreal coef, int line, int col);
    void addCoefficientDiagonal(qreal);
    void setCoefficient(qreal coef, int line, int col);
    void setCoefficients(const dtkContainerVector<qreal>&);
    void setZeroAllCoefficients(void);
    void setLineToIdentity(int line);

    void setNonZeroCoefficient(int line, int col);
    void setNonZeroCoefficientByBlockLineByLine(int line, int col, int size);
    void setNonZeroCoefficientLineByLine(const QVector<qlonglong>& line_sizes, const QVector<qlonglong>& col_indices);

    void startAtOneArrays(void);
    void startAtZeroArrays(void);
    
public:
    int lineNumber(void) const;
    int nonZeroCoefficientsNumber(void) const;
    int lineId(int line) const;
    int columnId(int id) const;
    qreal coefficient(int id) const;
    const dtkContainerVector<qreal>& coefficients(void) const;

    void productVector(const dtkContainerVector<qreal>& vector_in, dtkContainerVector<qreal>& vector_out) const;

    int *pointerLineVector(void);
    int *pointerColumnVector(void);
    double *pointerCoefficientVector(void);

public:
    carbonquantSparseMatrix& operator += (const qreal&);
    carbonquantSparseMatrix& operator -= (const qreal&);
    carbonquantSparseMatrix& operator *= (const qreal&);
    carbonquantSparseMatrix& operator /= (const qreal&);

private:
    DTK_DECLARE_PRIVATE(carbonquantSparseMatrix);
};

// /////////////////////////////////////////////////////////////////
// Debug operators
// /////////////////////////////////////////////////////////////////

CARBONQUANTHJB_EXPORT QDebug operator<<(QDebug dbg, carbonquantSparseMatrix&);
CARBONQUANTHJB_EXPORT QDebug operator<<(QDebug dbg, carbonquantSparseMatrix*);

Q_DECLARE_METATYPE(carbonquantSparseMatrix)
Q_DECLARE_METATYPE(carbonquantSparseMatrix*)

#endif


