/* carbonquantSparseMatrix_p.h ---
 */

/* Commentary: 
 * 
 */

/* Change log:
 * 
 */

#ifndef CARBONQUANTSPARSEMATRIX_P_H
#define CARBONQUANTSPARSEMATRIX_P_H

#include "carbonquantHJBExport.h"

#include <dtkCore/dtkAbstractData_p.h>

#include <dtkContainer/dtkContainerVector.h>

class carbonquantSparseMatrix;

////////////////////////////////////////////////////
// carbonquantSparseMatrixPrivate interface
////////////////////////////////////////////////////

class CARBONQUANTHJB_EXPORT carbonquantSparseMatrixPrivate : public dtkAbstractDataPrivate
{
public:
    carbonquantSparseMatrixPrivate(carbonquantSparseMatrix *q = 0) : dtkAbstractDataPrivate(q) {}
    carbonquantSparseMatrixPrivate(const carbonquantSparseMatrixPrivate& other) : dtkAbstractDataPrivate(other) {
        this->copy(other);
    }
    
public:
    virtual ~carbonquantSparseMatrixPrivate(void) {}
    
public:
    int line_number;
    int non_zero_coeff_number;

    dtkContainerVector<qreal> coefficients;
    dtkContainerVector<int> line_indices;
    dtkContainerVector<int> column_indices;

    void copy(const carbonquantSparseMatrixPrivate& other){

        line_number = other.line_number;
        non_zero_coeff_number = other.non_zero_coeff_number;
        coefficients = other.coefficients;
        line_indices = other.line_indices;
        column_indices = other.column_indices;

    }
};

////////////////////////////////////////////////////
// carbonquantSparseMatrix protected constructors
////////////////////////////////////////////////////

DTK_IMPLEMENT_PRIVATE(carbonquantSparseMatrix, dtkAbstractData);

#endif

