/* carbonquantStructuredGridBoundary.h --- 
 */

/* Commentary: 
 * 
 */

#ifndef CARBONQUANTSTRUCTUREDGRIDBOUNDARY_H
#define CARBONQUANTSTRUCTUREDGRIDBOUNDARY_H

#include "carbonquantHJBExport.h"

#include <dtkCore/dtkAbstractData.h>

class carbonquantStructuredGrid;

class carbonquantStructuredGridBoundaryPrivate;

// /////////////////////////////////////////////////////////////////
// carbonquantStructuredGridBoundary interface
// /////////////////////////////////////////////////////////////////

class CARBONQUANTHJB_EXPORT carbonquantStructuredGridBoundary : public dtkAbstractData
{
    Q_OBJECT

public:
     carbonquantStructuredGridBoundary(void);
     carbonquantStructuredGridBoundary(const carbonquantStructuredGridBoundary&);
    ~carbonquantStructuredGridBoundary(void);

public:
    carbonquantStructuredGridBoundary& operator = (const carbonquantStructuredGridBoundary&);
    
    bool operator == (const carbonquantStructuredGridBoundary& other) const;
    
public:
    QString description(void) const;
    QString  identifier(void) const;

public:
    void initialize(void);
    void setStructuredGrid(const carbonquantStructuredGrid*);
    void setMinimum(int, const qreal&);
    void setMaximum(int, const qreal&);

public:
    const qreal& minimum(int) const;
    const qreal& maximum(int) const;

private:
    DTK_DECLARE_PRIVATE(carbonquantStructuredGridBoundary);
};

// /////////////////////////////////////////////////////////////////
// carbonquantStructuredGridBoundary creation
// /////////////////////////////////////////////////////////////////

CARBONQUANTHJB_EXPORT dtkAbstractData *createCarbonquantStructuredGridBoundary(void);

// /////////////////////////////////////////////////////////////////
//
// /////////////////////////////////////////////////////////////////

Q_DECLARE_METATYPE(carbonquantStructuredGridBoundary);
Q_DECLARE_METATYPE(carbonquantStructuredGridBoundary *);

#endif
