/* carbonquantStructuredGrid_p.h --- 
 */

/* Commentary: 
 * 
 */

#ifndef CARBONQUANTSTRUCTUREDGRID_P_H
#define CARBONQUANTSTRUCTUREDGRID_P_H

#include "carbonquantHJBExport.h"

#include <dtkCore/dtkAbstractData_p.h>

#include <dtkContainer/dtkContainerVector.h>

class carbonquantStructuredGrid;

// /////////////////////////////////////////////////////////////////
// carbonquantStructuredGridPrivate interface
// /////////////////////////////////////////////////////////////////

class CARBONQUANTHJB_EXPORT carbonquantStructuredGridPrivate : public dtkAbstractDataPrivate
{
    DTK_DECLARE_PUBLIC(carbonquantStructuredGrid);

public:
    carbonquantStructuredGridPrivate(carbonquantStructuredGrid *q = 0) : dtkAbstractDataPrivate(q) {}
    carbonquantStructuredGridPrivate(const carbonquantStructuredGridPrivate& other) : dtkAbstractDataPrivate(other) {}

public:
    ~carbonquantStructuredGridPrivate(void) {}

public:
    int number_of_dimension;
    
    dtkContainerVector<qlonglong> number_of_points;

    dtkContainerVector<QString> names;

    dtkContainerVector<dtkContainerVector<qreal> > coordinates;
};

// /////////////////////////////////////////////////////////////////
// carbonquantStructuredGrid protected constructors
// /////////////////////////////////////////////////////////////////

DTK_IMPLEMENT_PRIVATE(carbonquantStructuredGrid, dtkAbstractData);

// /////////////////////////////////////////////////////////////////
// carbonquantStructuredGridPrivate documentation
// /////////////////////////////////////////////////////////////////

/*! \class carbonquantStructuredGridPrivate
 *
 *  \brief Class carbonquantStructuredGridPrivate is the private implementation of the
 *  carbonquantStructuredGrid class.
 *
 */

#endif
