#ifndef carbonquant_MATHS_INTERPOLATION_LINEAR_H
#define carbonquant_MATHS_INTERPOLATION_LINEAR_H

#include "carbonquantMathExport.h"

namespace Maths
{

namespace Interpolation
{

//! Linearly interpolates a given set of points.

class CARBONQUANTMATH_EXPORT Linear
{
public:
    Linear(int n, const double *x, const double *y);
    ~Linear();

//! Returns an interpolated value.
    double value(double x);

//! A static function implementing the Linear Class for one off calculations
    static double value(int N, const double *x, const double *y, double a);

private:
    double *m_x, *m_y;
};

}

}

#endif

