#ifndef carbonquant_Control_h
#define carbonquant_Control_h

#include "carbonquantModelProductElecExport.h"

#include <vector>

class Power;
class Spot;
class Utility;
class Tax;

/* A simple Control Function Class
 */
class CARBONQUANTMODELPRODUCTELEC_EXPORT Control {
protected:
    std::vector<double> m_spot_state;
    std::vector<double> m_emission_state;
    std::vector<double> m_control;
    const Power* power;
    const Utility* utility;
    const Tax* tax;

public:
    Control() {};
    Control(const Power* p, const Utility* u, const Tax* t);
    ~Control();

// Copy
public:
    Control(const Control& control);
    Control& operator = (const Control& control);

public:
    void setSpotState(const std::vector<double>& spot_state);
    void setEmissionState(const std::vector<double>& emission_state);

public:
    const std::vector<double>& control_marginalCost(void);
    const std::vector<double>& control_conditionalMarginalCost(void);
    const std::vector<double>& control_optimalHJB (const double& alpha, const double& beta);
};

#endif // carbonquant_Control_h
