#ifndef carbonquant_Emission_h
#define carbonquant_Emission_h

#include "carbonquantModelProductElecExport.h"

#include <cmath>
#include <iostream>
#include <assert.h>
#include <stdlib.h>
#include <vector>

class Power;

/* A simple Emission Function Class
 */
class CARBONQUANTMODELPRODUCTELEC_EXPORT Emission {
protected:
    double m_time;
    std::vector<double> m_control;
    const Power* power;
    double initialEmission;

    std::vector<double> m_drift;

public:
    void setTime(double time);
    void setControl(const std::vector<double>& control);

public:
    Emission() {};
    Emission(const Power* p, double initialEmission = 0);
    ~Emission();

// Copy
public:
    Emission(const Emission& emission);
    Emission& operator = (const Emission& emission);

public:
    const std::vector<double>& drift(void);
    double totalEmission(void);

    void setInitialEmission(const double& emission) {this->initialEmission = emission;};

    inline const double& getInitialEmission(void) const {return initialEmission;};
};

#endif // carbonquant_Emission_h
