#ifndef carbonquant_Tax_h
#define carbonquant_Tax_h

#include "carbonquantModelProductElecExport.h"

#include <cmath>
#include <iostream>
#include <assert.h>
#include <stdlib.h>
#include <algorithm>

/** A simple Tax Class
 */
class CARBONQUANTMODELPRODUCTELEC_EXPORT Tax {
private:
  double theta_0; // tax strike (allocation init)
  double gamma_0; // tax slope
public:
  Tax() : theta_0(0.0), gamma_0(0.0) {};
  Tax(double theta, double gamma);
  Tax(double gamma);
  ~Tax();

  void setInitialAllocation(const double& theta) {this->theta_0 = theta;}
  void setTaxRate(const double& gamma) {this->gamma_0 = gamma;}

  double getTaxRate() const {return gamma_0;};
  double getInitialAllocation() const{return theta_0;};

  double getTax(double x) const {return (x >= theta_0)?gamma_0*(x-theta_0):0;};
  double getTaxPrime(double x) const {return (x >= theta_0)?gamma_0:0;};
};

#endif // carbonquant_Tax_h
