#ifndef carbonquant_Utility_h
#define carbonquant_Utility_h

#include "carbonquantModelProductElecExport.h"

#include <cmath>
#include <iostream>
#include <assert.h>
#include <stdlib.h>
#include <vector>

/* A simple Utility Function Class
 */
class CARBONQUANTMODELPRODUCTELEC_EXPORT Utility {
private:
  double rho; // elasticity
public:
  Utility() : rho(0.0) {};
  Utility(double r);
  ~Utility();

  void setElasticity(const double& rho) {this->rho = rho;}

  double getElasticity() const {return rho;}

  double getUtility(double x) const {return (1.0 - exp(-rho*x))/rho;};
  double getUtilityPrime(double x) const {return rho*exp(-rho*x);};

  double get3DUtility(double x_wealth) const {return (1-exp(-rho*x_wealth))/rho ;};
  double get3DUtilityPrime(double x_wealth) const {return exp(-rho*x_wealth);};

  double get2DUtility(double x_emission) const {return exp(-rho*x_emission);};
  double get2DUtilityPrime(double x_emission) const {return -rho*exp(-rho*x_emission);};

  double get1DUtility(double x) const {return 1.0;};
  double get1DUtilityPrime(double x) const {return 0.0;};
};

#endif // carbonquant_Utility_h
