#ifndef carbonquant_Wealth_h
#define carbonquant_Wealth_h

#include "carbonquantModelProductElecExport.h"

#include <cmath>
#include <vector>

class Power;

/* A simple Wealth Function Class
 */
class CARBONQUANTMODELPRODUCTELEC_EXPORT Wealth {

protected:
    double m_time;
    std::vector<double> m_spot_state;
    std::vector<double> m_control;
    const Power* power;
    double Q_otc;
    double P_otc;
    double initialWealth;

protected:
    double m_drift;

public:
    void setTime(double time);
    void setSpotState(const std::vector<double>& spot_state);
    void setControl(const std::vector<double>& control);

public:
    Wealth() {};
    Wealth(const Power* power, double Q_otc=0.0, double P_otc=0.0, double initialWealth=0.0);
    ~Wealth();

// Copy
public:
    Wealth(const Wealth& wealth);
    Wealth& operator = (const Wealth& wealth);

public:
    const double& drift(void);

    void setQ_otc(const double& qotc) {this->Q_otc = qotc;};
    void setP_otc(const double& potc) {this->P_otc = potc;};
    void setInitialWealth(const double& wealth) {this->initialWealth = wealth;};

    inline const double& getQ_otc(void) const {return Q_otc;};
    inline const double& getP_otc(void) const {return P_otc;};
    inline const double& getInitialWealth(void) const {return initialWealth;};
};

#endif // carbonquant_Wealth_h
