#ifndef carbonquant_SpotExponentialOU2_h
#define carbonquant_SpotExponentialOU2_h

//
// S_t = s_const *(  exp( X_t^2 ) + a_const ) where X_t est un OU process
//

#include "SpotOU.h"

// Function Added By El Hadj Nov 2011
class CARBONQUANTMODELSPOT_EXPORT SpotExponentialOU2 : public SpotOU 
{
protected:  
    double s_const;
    double a_const;

public:
     SpotExponentialOU2(double sconst=1, double aconst=-1) { s_const = sconst; a_const = aconst;};
     SpotExponentialOU2(double alpha, double sigma, double mu, double sconst=1, double aconst=-1);
    ~SpotExponentialOU2(void);

// Copy
public:
    SpotExponentialOU2(const SpotExponentialOU2& spot);
    SpotExponentialOU2& operator = (const SpotExponentialOU2& spot);

public:
    virtual SpotExponentialOU2* clone(void) const;

    //----------- returns kind of the spot -------------------------------------
    std::string identifier(void) const { return "SpotExponentialOU2"; }

    virtual Model get_model(void) const { return EXP_OU2; }
  
    //
    const std::vector<std::vector<double> >& diffusion(void);
    const std::vector<double>& drift(void);

    //--------------------------------------------------------------------------
    virtual void set_spot_scale(const double& spot_scale) { this->s_const = spot_scale; };

    //--------------------------------------------------------------------------
    virtual double get_spot_scale() const { return s_const;};

    //-----------  function to simulate a spot ----------------------------------
    // function two simulate spot between two time
    virtual double simulate(const double &dt, const double &spotValue) const;

    virtual void print_model_param() const;
};

#endif //  carbonquant_SpotExponentialOU2_h
