#ifndef carbonquant_SpotModifiedOU_h
#define carbonquant_SpotModifiedOU_h

#include "SpotOU.h"

// #include "carbonquantExport.h"
class CARBONQUANTMODELSPOT_EXPORT SpotModifiedOU : public SpotOU
{
public:
     SpotModifiedOU(double alpha, double sigma, double mu);
    ~SpotModifiedOU(void);

// Copy
public:
    SpotModifiedOU(const SpotModifiedOU& spot);
    SpotModifiedOU& operator = (const SpotModifiedOU& spot);

public:
    virtual SpotModifiedOU* clone(void) const;

    //----------- returns kind of the spot -------------------------------------
    std::string identifier(void) const { return "SpotModifiedOU"; }

    virtual Model get_model(void) const { return MODIFIED_OU; }

    //
    const std::vector<std::vector<double> >& diffusion(void);
    const std::vector<double>& drift(void);

    //-----------  function to simulate a spot ----------------------------------
    virtual double simulate(const double &dt, const double &spotValue) const;
};

#endif // carbonquant_SpotModifiedOU_h
