#ifndef carbonquant_SpotOU_h
#define carbonquant_SpotOU_h

#include "Spot.h"

class CARBONQUANTMODELSPOT_EXPORT SpotOU : public Spot
{
protected:
    double volatility;      // sigma
    double meanParameter;   //    mu 
    double meanReversion;   // alpha 

public:
     SpotOU() {}; // : volatility(sigma), meanParameter(mu), meanReversion(alpha){};
     SpotOU(double alpha, double sigma, double mu); // : volatility(sigma), meanParameter(mu), meanReversion(alpha){};
    ~SpotOU(void);

// Copy
public:
    SpotOU(const SpotOU& spot);
    SpotOU& operator = (const SpotOU& spot);

public:
    virtual SpotOU* clone(void);

    //----------- returns kind of the spot -------------------------------------
    std::string identifier(void) const { return "SpotOU"; }

    virtual Model get_model(void) const { return OU; }

    //
    const std::vector<std::vector<double> >& diffusion(void);
    const std::vector<double>& drift(void);

    //---------------------------------------------------------------------------
    virtual void set_volatility(const double& volatility) { this->volatility = volatility; };
    virtual void set_meanParameter(const double& meanParameter) { this->meanParameter = meanParameter; }; 
    virtual void set_meanReversion(const double& meanReversion) { this->meanReversion = meanReversion; };

    //---------------------------------------------------------------------------
    virtual double get_volatility() const { return volatility; };
    virtual double get_meanParameter() const { return meanParameter; }; 
    virtual double get_meanReversion() const { return meanReversion; };

    //-----------  function to simulate a spot ----------------------------------
    // function two simulate spot between two time
    virtual double simulate(const double &dt, const double &spotValue) const;
};

#endif  // carbonquant_SpotOU_h
