/*****************************************************************************
 * MapOptimizer
 * 2010-06-21
 * REGIS DUVIGNEAU  
 * 
 *****************************************************************************
 *               Copyright (C) 2006 INRIA Sophia-Antipolis
 ************************************************************************
 * Comments : list of constant parameters used for mapping
 ****************************************************************************/

#ifndef carbonquant_MAPOPTIMIZER_H
#define carbonquant_MAPOPTIMIZER_H

// Optimization algorithms
const int EVOLUTION_STRATEGY = 0;
const int STEEPEST_DESCENT = 1;
const int SIMPLEX = 2;
const int PARETO_ARCHIVED = 3;
const int QUASI_NEWTON = 4;
const int CONJUGATE_GRADIENT_FR = 5;
const int CONJUGATE_GRADIENT_PR = 6;
const int EFFICIENT_GLOBAL_OPT = 7;
const int EVOLUTION_STRATEGY_CMA = 8;

// Status of descent direction-based methods ( gradient & quasi-newton )
const int STATUS_DESCENT = 0;
const int STATUS_LINE_SEARCH = 1;

// Status of simplex method
const int STATUS_INIT = 0;
const int STATUS_REFLECTION = 1;
const int STATUS_EXPANSION = 2;
const int STATUS_CONTRACTION = 3;

#endif
