#ifndef carbonquant_CHPCONCAVE_H
#define carbonquant_CHPCONCAVE_H

#include "carbonquantPlantsExport.h"

#include "SingleCycleCHP.h"

#include <carbonquantCogenerationParkModel/MeritOrder/MeritOrderAlloc.h>

#include <vector>

class RegularTransitionCost;
class PiecewiseLinearConcaveProductionFunction;

class CARBONQUANTPLANTS_EXPORT CHPConcave : public SingleCycleCHP
{
public:
    CHPConcave(PiecewiseLinearConcaveProductionFunction* pwlcProd = NULL, RegularTransitionCost* rtcfunc = NULL);

    ~CHPConcave();

    void setPdtFunc(PiecewiseLinearConcaveProductionFunction* pdtfunc) {this->pdtfunc = pdtfunc;};

    PiecewiseLinearConcaveProductionFunction* getPdtFunc() const {return pdtfunc;};

    void comp_bestOP();

    std::vector<MeritOrderAlloc::Object*>& getVpp() {return vpp;};
    unsigned int& getIdx_reg_xHde_last() {return idx_reg_xHde_last;};
    bool& isDecomposed() {return Isdecomposed;};
    bool& isAdded_reg_xHde() {return IsAdded_reg_xHde;};

protected:
    PiecewiseLinearConcaveProductionFunction* pdtfunc;
    mutable bool Isdecomposed;
    mutable bool IsAdded_reg_xHde;
    mutable unsigned int idx_reg_xHde_last;
    mutable std::vector<MeritOrderAlloc::Object*> vpp;
};

#endif
