#ifndef carbonquant_ENERGYPLANT_H
#define carbonquant_ENERGYPLANT_H

#include "carbonquantPlantsExport.h"

#include <string>

class RegularTransitionCost;

class CARBONQUANTPLANTS_EXPORT EnergyPlant
{
public:
    struct OPoint
    {
        double elec;
        double fuel;
        double heat;
        double emis;
    };

    struct Prices
    {
        double bid_elec;
        double ask_elec;
        double elec;
        double fuel;
        double emis;
        double temperature;
    };

    enum Type
    {
        POWERPLANT,
        BOILER,
        CHPLINEAR,
        CHPCONCAVE,
        CHPCCG
    };

public:
    EnergyPlant();
    virtual ~EnergyPlant();

    virtual void comp_bestOP() {};

    //setters

    void setName(const std::string& name) {this->name = name;};
    void setBestOP(const OPoint& bestOP) {this->bestOP = bestOP;};
    void setRegularTransitionCost(RegularTransitionCost* rtcfunc) {this->rtcfunc = rtcfunc;};

    //getters

    const std::string& getName() const {return name;};
    OPoint& getBestOP() const {return bestOP;};
    Type getType() const {return type;};
    RegularTransitionCost* getRegularTransitionCost() const {return rtcfunc;};
    Prices& getLastP() {return lastP;};

protected:
    std::string name;
    Type type;
    mutable OPoint lastOP;
    mutable OPoint bestOP;
    Prices lastP;
    RegularTransitionCost* rtcfunc;
};

#endif
