#ifndef carbonquant_PowerArray_h
#define carbonquant_PowerArray_h

#include "carbonquantPlantsExport.h"

#include "Power.h"

#include <assert.h>
#include <vector>

class PowerPlant;

class CARBONQUANTPLANTS_EXPORT PowerArray : public Power
{
private:
  const std::vector<PowerPlant>* power_plants;
  int numberOfPowerPlants;
  double* array_prod_cost;
  double* array_emission_rate;
  double* array_capacity;

public:
  PowerArray();
  PowerArray(const std::vector<PowerPlant>* v);  
  virtual ~PowerArray();
  
  virtual int getNumberOfPowerPlants() const;

  // accesor array
  double getCapacity( int i) const { assert( i>=0 && i<numberOfPowerPlants); return array_capacity[i]; };
  double getProdCost( int i) const { assert( i>=0 && i<numberOfPowerPlants); return array_prod_cost[i]; };
  double getEmissionRate( int i) const { assert( i>=0 && i<numberOfPowerPlants); return array_emission_rate[i]; };
};

#endif // carbonquant_PowerArray_h
