#ifndef carbonquant_POWERPLANT_H
#define carbonquant_POWERPLANT_H

#include "carbonquantPlantsExport.h"

#include <carbonquantPlants/EnergyPlant.h>

class LinearProductionFunction;
class RegularTransitionCost;

class CARBONQUANTPLANTS_EXPORT PowerPlant : public EnergyPlant
{
public:
    PowerPlant();
    PowerPlant(double maxcap, double mcost, double erate, std::string name = "PowerPlant");
    ~PowerPlant();

    PowerPlant(const PowerPlant& p);

    PowerPlant& operator = (const PowerPlant& p);

    double getCapacity() const {return capacity;};
    double getEmissionRate() const {return emission_rate;};
    double getProductionCost() const {return production_cost;};
    LinearProductionFunction* getPdtFunc() const {return pdtfunc;};

    void setCapacity(const double& capacity) {this->capacity = capacity;};
    void setEmissionRate(const double& emission_rate) {this->emission_rate = emission_rate;};
    void setProductionCost(const double& production_cost) {this->production_cost = production_cost;};
    void setPdtFunc(LinearProductionFunction* pdtfunc) {this->pdtfunc = pdtfunc;};

private:
    double capacity;
    double production_cost;
    double emission_rate;
    LinearProductionFunction* pdtfunc;
};

#endif
