/* carbonquantChartView.h --- 
 */

/* Commentary: 
 * 
 */ 

#ifndef CARBONQUANTCHARTVIEW_H
#define CARBONQUANTCHARTVIEW_H

#include "carbonquantPlotExport.h"

#include <dtkCore/dtkAbstractView.h>

#include <QtCore>
#include <QtGui>

class carbonquantChartViewPrivate;

class CARBONQUANTPLOT_EXPORT carbonquantChartView : public dtkAbstractView
{
    Q_OBJECT

public:
    enum Type {
        Histogram,
        Pie,
        Pie3D
    };

    enum LegendType{
        Vertical,
        Round
    };

public:
    carbonquantChartView(void);
    carbonquantChartView(const carbonquantChartView&) {};
    virtual ~carbonquantChartView(void);

public:
    carbonquantChartView& operator=(const carbonquantChartView&) {};

    void setTitle(const QString&);
    void setTitleSize(const int&);
    const QString& title(void) const;
    int titleSize(void) const;

    void setNames(const QStringList&);
    const QStringList& names(void) const;

    void setColors(const QStringList&);
    const QStringList& colors(void) const;

    void setData(const QStringList&);
    QStringList dataStringList(void) const;

    void setData(const QVector<double>&);
    const QVector<double>& data(void) const;

    void setType(carbonquantChartView::Type);

    void setLegendType(carbonquantChartView::LegendType);
    void setLegendSize(const int&);
    int legendSize(void) const;

    void setShadows(bool ok = true);
    void setFont(QFont);

    void setBackgroundColor(const QColor&);
    const QColor& backgroundColor(void) const;

    void setForegroundColor(const QColor&);
    const QColor& foregroundColor(void) const;

    void clear(void);

    QWidget* widget(void);

public:
    virtual QString identifier(void) const;

    static bool registered(void);

protected:
    void addPiece(QString, QColor, double, double);

    void updateColors(void);

public slots:
    void update(void);

    void onExport(void);

private:
    carbonquantChartViewPrivate *d;
};

CARBONQUANTPLOT_EXPORT dtkAbstractView *createChartView(void);

#endif
