/* carbonquantColorMap.h --- 
 */

/* Commentary: 
 * 
 */

#ifndef CARBONQUANTCOLORMAP_H
#define CARBONQUANTCOLORMAP_H

#include "carbonquantPlotExport.h"

#include <dtkCore/dtkGlobal.h>

#include <qwt_color_map.h>

class carbonquantColorMapPrivate;

class CARBONQUANTPLOT_EXPORT carbonquantColorMap: public QwtLinearColorMap
{
public:
     carbonquantColorMap();
     carbonquantColorMap(const QString&);
    ~carbonquantColorMap(void);

    void setName(const QString&);
    void chooseColor(const int&, const bool& whiteBegin = false);

    void setColorMap(const QVector<QColor>&);
    QVector<QColor> colorMap() const;

public:
    static QStringList colorsPanel(void);
    static QStringList randomColors(int, bool reverseDirection = false);

protected:

    void setColorSpectral(void);
    void setColorTango(void);
    void setColorColdHot(void);
    void setColorCandleLight(void);
    void setColorSandyShades(void);
    void setColorLines(void);
    void setColorJet(void);
    void setColorGray(void);
    void update(void);
    void init(void);

private:
    carbonquantColorMapPrivate *d;
};

#endif
