/* carbonquantMultipleViews.h --- 
 */

/* Commentary: 
 * 
 */

#ifndef CARBONQUANTMULTIPLEVIEWS_H
#define CARBONQUANTMULTIPLEVIEWS_H

#include "carbonquantPlotExport.h"

#include <dtkCore/dtkAbstractView.h>

class carbonquantMultipleViewsPrivate;

class CARBONQUANTPLOT_EXPORT carbonquantMultipleViews : public dtkAbstractView
{
    Q_OBJECT

public:
     carbonquantMultipleViews(void);
    ~carbonquantMultipleViews(void);

    void addView(dtkAbstractView *view);

    void clear(void);

    void setTitle(const QString&);
    void setTitleSize(const int&);

    QString title(void) const;
    int titleSize(void) const;

    void setBackgroundColor(const QColor&);
    const QColor& backgroundColor(void) const;

    void setForegroundColor(const QColor&);
    const QColor& foregroundColor(void) const;

    void setBorderColor(const QColor&);
    const QColor& borderColor(void) const;

    void setNumberOfColumnsOfViews(int);

    void updateColors(void);

    void setStyleSheet(const QString&);

    const QList<dtkAbstractView*>& views(void);

    QList<const dtkAbstractView*> views(void) const;

    QWidget* widget(void);

public:
    virtual QString identifier(void) const;

    static bool registered(void);

public slots:
    void update(void);

    void onExport(void);

private:
    carbonquantMultipleViewsPrivate *d;
};

CARBONQUANTPLOT_EXPORT dtkAbstractView *createMultipleViews(void);

#endif
