/* carbonquantPlot3DView.h --- 
 */

/* Commentary: 
 * 
 */

#ifndef CARBONQUANTPLOT3DVIEW_H
#define CARBONQUANTPLOT3DVIEW_H

#include "carbonquantPlotExport.h"

#include <dtkCore/dtkAbstractView.h>

#include <dtkContainer/dtkContainerVector.h>

class carbonquantPlot3DViewPrivate;

class CARBONQUANTPLOT_EXPORT carbonquantPlot3DView : public dtkAbstractView
{
    Q_OBJECT

public:
    enum Scale {
        Linear,
        Logarithmic
    };

    enum LegendOrientation {
        BottomTop,
        LeftRight
    };

public:
     carbonquantPlot3DView(QWidget *parent = 0);
     carbonquantPlot3DView(const carbonquantPlot3DView&) {};
    ~carbonquantPlot3DView(void);

public:
    carbonquantPlot3DView& operator=(const carbonquantPlot3DView&) {};
    
    void clear(void);

    void setTitle(const QString&);
    void setTitleSize(const int&);
    QString title(void) const;
    int titleSize(void) const;

    void setAxisTitleX(const QString&);
    void setAxisTitleY(const QString&);
    void setAxisTitleZ(const QString&);

    QString axisTitleX(void) const;
    QString axisTitleY(void) const;
    QString axisTitleZ(void) const;

    void setAxisTitleSize(const int&);
    int axisTitleSize() const;

    void setAxisScaleX(const double&, const double&);
    void setAxisScaleY(const double&, const double&);
    void setAxisScaleZ(const double&, const double&);

    void setAxisScaleX(Scale);
    void setAxisScaleY(Scale);
    void setAxisScaleZ(Scale);

    void setBackgroundColor(const QColor&);
    const QColor& backgroundColor(void) const;

    void setForegroundColor(const QColor&);
    const QColor& foregroundColor(void) const;

    void setStyleSheet(const QString&);

    void setLegendTitle(const QString&);
    QString legendTitle(void) const;
    void setLegendVisible(bool);
    bool isLegendVisible(void) const;
    void setLegendOrientation(LegendOrientation);
    LegendOrientation legendOrientation(void) const;
    void setLegendSize(const int&);
    int legendSize(void) const;

    void setBoxVisible(bool);
    bool isBoxVisible(void) const;

    void setData(const dtkContainerVectorReal*, const dtkContainerVectorReal*, const dtkContainerVectorReal*);
    const dtkContainerVectorReal* dataX(void) const;
    const dtkContainerVectorReal* dataY(void) const;
    const dtkContainerVectorReal* dataZ(void) const;

    qlonglong numberOfPointsX(void) const;
    qlonglong numberOfPointsY(void) const;
    qlonglong numberOfPointsZ(void) const;

    void isolines(int, int, double, QList<QVector<double> >&, QList<QVector<double> >&);

    QWidget* widget(void);

    QString content(void) const;

public:
    virtual QString identifier(void) const;

    static bool registered(void);

protected:
    void updateScale(void);

    void updateColorsLegend(int, int);

public slots:
    void update(void);

    void onExport(void);

private:
    carbonquantPlot3DViewPrivate *d;
};

CARBONQUANTPLOT_EXPORT dtkAbstractView *createPlot3DView(void);

#endif
