/* carbonquantPlotCurve.h --- 
 */

/* Commentary: 
 * 
 */

#ifndef CARBONQUANTPLOTCURVE_H
#define CARBONQUANTPLOTCURVE_H

#include "carbonquantPlotExport.h"

#include <qwt_interval.h>

#include <QtCore>

class carbonquantPlotCurvePrivate;

class CARBONQUANTPLOT_EXPORT carbonquantPlotCurve : public QObject
{
    Q_OBJECT

public:
    enum Style {
        Lines,
        Dots,
        Cross
    };

public:
     carbonquantPlotCurve(const QString& title = QString());
     carbonquantPlotCurve(const carbonquantPlotCurve&) {};
    ~carbonquantPlotCurve(void);

public:
    carbonquantPlotCurve& operator=(const carbonquantPlotCurve&) {};

    void setAntialiased(bool);
    void setStyle(Style style = Lines);
    void setTitle(const QString&);
    void setColor(const QColor&);
    void setColorArea(const QColor&);
    void setData(const QVector<QPointF>&);

    QString title(void) const;
    const QColor& color(void) const;

    void showLegend(bool);

    void setInterval(const double&, const double&, const double&, const double&);
    const QwtInterval& intervalAxisX(void) const;
    const QwtInterval& intervalAxisY(void) const;

    int dataSize(void) const;
    double sampleX(const int&) const;
    double sampleY(const int&) const;

public slots:
    void detach(void);

private:
    friend class carbonquantPlotView;

private:
    carbonquantPlotCurvePrivate *d;
};

typedef QList<carbonquantPlotCurve *> carbonquantPlotCurves;

Q_DECLARE_METATYPE(carbonquantPlotCurve);
Q_DECLARE_METATYPE(carbonquantPlotCurve *);
Q_DECLARE_METATYPE(carbonquantPlotCurves);
Q_DECLARE_METATYPE(carbonquantPlotCurves *);

#endif
