/* carbonquantPlotGrid.h --- 
 */

/* Commentary: 
 * 
 */

#ifndef CARBONQUANTPLOTGRID_H
#define CARBONQUANTPLOTGRID_H

#include "carbonquantPlotExport.h"

#include <QtGui/QFrame>

class carbonquantPlotGridPrivate;

class CARBONQUANTPLOT_EXPORT carbonquantPlotGrid : public QFrame
{
    Q_OBJECT

public:
    carbonquantPlotGrid(const int& numberOfColumns = 1, QWidget *parent = 0);
    ~carbonquantPlotGrid(void);

    void addWidget(QWidget*);
    void removeWidget(QWidget*);
    void removeAllWidgets(void);

    int numberOfWidgets(void) const;

    QWidget* widget(int) const;
    QWidget* viewport(void) const;

    void update(void);

    void setBackgroundColor(const QColor&);
    void setForegroundColor(const QColor&);

    void clear(void);

protected:
    void updateStyleSheet(void);

    void placeWidgets(void);

public slots:
    void setNumberOfColumns(const int&);

private:
    carbonquantPlotGridPrivate *d;
};

#endif
