/* carbonquantPlotHistogram.h --- 
 */

/* Commentary: 
 * 
 */

#ifndef CARBONQUANTPLOTHISTOGRAM_H
#define CARBONQUANTPLOTHISTOGRAM_H

#include "carbonquantPlotExport.h"

#include <qwt_series_data.h>

#include <QtCore>

class carbonquantPlotHistogramPrivate;

class CARBONQUANTPLOT_EXPORT carbonquantPlotHistogram : public QObject
{
    Q_OBJECT

public:
     carbonquantPlotHistogram(const QString& title = QString());
     carbonquantPlotHistogram(const carbonquantPlotHistogram&) {};
    ~carbonquantPlotHistogram(void);

public:
    carbonquantPlotHistogram& operator=(const carbonquantPlotHistogram&) {};

    void setColor(const QColor&);
    void setPen(const QColor&);

    uint dataSize(void);
    void setData(const QVector<QwtIntervalSample>&);

    void setInterval(const double&, const double&, const double&, const double&);
    const QwtInterval& intervalAxisX(void);
    const QwtInterval& intervalAxisY(void);

public slots:
    void detach(void);

private:
    friend class carbonquantPlotView;

private:
    carbonquantPlotHistogramPrivate *d;
};

Q_DECLARE_METATYPE(carbonquantPlotHistogram);
Q_DECLARE_METATYPE(carbonquantPlotHistogram *);

#endif
