/* dtkComposerNodeArrayScalarOperatorBinary.h ---
 */

/* Commentary:
 *
 */

#ifndef DTKCOMPOSERNODEARRAYSCALAROPERATORBINARY_H
#define DTKCOMPOSERNODEARRAYSCALAROPERATORBINARY_H

#include "dtkComposerExport.h"
#include "dtkComposerNodeLeaf.h"

// /////////////////////////////////////////////////////////////////
// dtkComposerNodeArrayScalarOperatorBinary interface
// /////////////////////////////////////////////////////////////////

class dtkComposerNodeArrayScalarOperatorBinaryPrivate;

class DTKCOMPOSER_EXPORT dtkComposerNodeArrayScalarOperatorBinary : public dtkComposerNodeLeaf
{
public:
    dtkComposerNodeArrayScalarOperatorBinary(void);
    ~dtkComposerNodeArrayScalarOperatorBinary(void);

public:
    inline QString inputLabelHint(int port) {
        if (port == 0)
            return "array_lhs";
        else if (port == 1)
            return "array_rhs";

        return "port";
    }

    inline QString outputLabelHint(int) {
        return "array";
    }

protected:
    dtkComposerNodeArrayScalarOperatorBinaryPrivate *d;
};

// /////////////////////////////////////////////////////////////////
// dtkComposerNodeArrayScalarOperatorBinary - SUM
// /////////////////////////////////////////////////////////////////

class DTKCOMPOSER_EXPORT dtkComposerNodeArrayScalarOperatorBinarySum : public dtkComposerNodeArrayScalarOperatorBinary
{
public:
    void run(void);

public:
    inline QString type(void) {
        return "array_scalar_sum_array_scalar";
    }

    inline QString titleHint(void) {
        return "Scalar array sum scalar array";
    }
};

// /////////////////////////////////////////////////////////////////
// dtkComposerNodeArrayScalarOperatorBinary - Substract
// /////////////////////////////////////////////////////////////////

class DTKCOMPOSER_EXPORT dtkComposerNodeArrayScalarOperatorBinarySubstract : public dtkComposerNodeArrayScalarOperatorBinary
{
public:
    void run(void);

public:
    inline QString type(void) {
        return "array_scalar_substract_array_scalar";
    }

    inline QString titleHint(void) {
        return "Scalar array substract scalar array";
    }
};

#endif
