/* dtkComposerNodeArrayScalarReader.h ---
 */

/* Commentary:
 *
 */

#ifndef DTKCOMPOSERNODEARRAYSCALARREADER_H
#define DTKCOMPOSERNODEARRAYSCALARREADER_H

#include "dtkComposerExport.h"
#include "dtkComposerNodeLeaf.h"

class dtkComposerNodeArrayScalarReaderPrivate;

// /////////////////////////////////////////////////////////////////
// dtkComposerNodeArrayScalarReader interface
// /////////////////////////////////////////////////////////////////

class dtkComposerNodeArrayScalarReaderPrivate;

class DTKCOMPOSER_EXPORT dtkComposerNodeArrayScalarReader : public dtkComposerNodeLeaf
{
public:
     dtkComposerNodeArrayScalarReader(void);
    ~dtkComposerNodeArrayScalarReader(void);

public:
    void run(void);

public:
    inline QString type(void) {
        return "array_scalar_reader";
    }

    inline QString titleHint(void) {
        return "Scalar array : reader";
    }

public:
    QString  inputLabelHint(int port);
    QString outputLabelHint(int port);

protected:
    bool open(const QString& fileName);
    bool readContent(const QString& content);
    bool readFile(const QString& fileName);

private:
    dtkComposerNodeArrayScalarReaderPrivate *d;
};

#endif

